#include<stdlib.h>
#include<stdio.h>
#include "lista.h"

void insertarListaVacia(Lista *lista){

    Nodo *nuevoNodo = malloc(sizeof(Nodo *));
    nuevoNodo->valor = 1;
    nuevoNodo->siguiente = NULL;
    lista->cabeza = nuevoNodo;
    lista->longitud += 1;
}

int esVacia(Lista *lista){

    if(lista->cabeza == NULL){
        return 1;
    }else{
        return 0;
    }

}

void insertarFinal(Lista *lista){

    Nodo *nuevoNodo = malloc(sizeof(Nodo *));
    Nodo *actual = lista->cabeza;

    while(actual->siguiente!=NULL){
        actual = actual->siguiente;
    }

    nuevoNodo->valor = actual->valor+1;
    nuevoNodo->siguiente = NULL;

    actual->siguiente = nuevoNodo;
    lista->longitud += 1;

}

void insertarPosicion(Lista *lista, int posicion){

    Nodo *nuevoNodo = malloc(sizeof(Nodo *));
    Nodo *actual = lista->cabeza;
    Nodo *aux;
    int i=1;

    while(i<posicion-1){
        actual = actual->siguiente;
        i++;
    }
    aux = actual->siguiente;
    nuevoNodo->valor=99;
    actual->siguiente = nuevoNodo;
    nuevoNodo->siguiente = aux;
    lista->longitud += 1;

}

void inicializacion (Lista *lista){
    lista->cabeza = NULL;
    lista->longitud = 0;
}



void imprimirLista(Lista *lista){
    Nodo *nodoActual;
    nodoActual = lista->cabeza;

    while (nodoActual != NULL){
        printf ("%d ",nodoActual->valor);
        nodoActual = nodoActual->siguiente;
    }

    printf("\n");
}


void insertarInicio(Lista *lista){

    Nodo *nuevoNodo = malloc(sizeof(Nodo *));
    nuevoNodo->valor = 0;
    nuevoNodo->siguiente = lista->cabeza;

    lista->cabeza = nuevoNodo;
    lista->longitud += 1;

}

void eliminarInicio(Lista *lista){
    lista->cabeza = lista->cabeza->siguiente;
    lista->longitud -=1;
}

void eliminarFinal(Lista *lista){

    Nodo *actual = lista->cabeza;
    int i =1;
    while(i<lista->longitud-1){
        actual = actual->siguiente;
        i++;
    }
    actual->siguiente= NULL;
    lista->longitud -=1;
}

int buscarElemento(Lista *lista, int buscado){

    Nodo *nodoActual;
    nodoActual = lista->cabeza;
    int posicion = -1;
    int i=0;

    while (nodoActual != NULL){
        if(nodoActual->valor==buscado){
            posicion = i;
            break;
        }else{
            nodoActual = nodoActual->siguiente;
            i+=1;
        }

    }

    return posicion;
}



void eliminarPosicion(Lista *lista, int posicion){

    Nodo *actual = lista->cabeza;
    int i=1;

    while(i<posicion-1){
        actual = actual->siguiente;
        i++;
    }

    actual->siguiente = actual->siguiente->siguiente;


    lista->longitud -= 1;

}


